unit uMath_Vec;

interface
  // Wektor 3D

type
  PVector3D = ^TVector3D;
  TVector3D = packed record
    case Integer of
      0: (M: array[0..2] of single);
      1: (x, y, z: single; );
  end;

const
  v3Dnil: TVector3D = (x: 0; y: 0; z: 0);

function Vector3D(const AX, AY, AZ: single): TVector3D;
function Vector3D_Add(const Ava, Avb: TVector3D): TVector3D;
function Vector3D_Sub(const Ava, Avb: TVector3D): TVector3D;
function Vector3D_Scale(const Ava: TVector3D; const Ak: single): TVector3D;
function Vector3D_Clamp(var Ava: TVector3D; const sMax: single): TVector3D;
implementation

{------------------------------------------------------------------------------}
{ Nowy wektor}

function Vector3D(const AX, AY, AZ: single): TVector3D;
begin
  Result.x := AX;
  Result.y := AY;
  Result.z := AZ;
end;

{------------------------------------------------------------------------------}
{ Dodawanie wektorow}

function Vector3D_Add(const Ava, Avb: TVector3D): TVector3D;
begin
  Result.x := Ava.x + Avb.x;
  Result.y := Ava.y + Avb.y;
  Result.z := Ava.z + Avb.z;
end;

{------------------------------------------------------------------------------}
  { Odejmowanie wektorow}

function Vector3D_Sub(const Ava, Avb: TVector3D): TVector3D;
begin
  Result.x := Ava.x - Avb.x;
  Result.y := Ava.y - Avb.y;
  Result.z := Ava.z - Avb.z;
end;

{------------------------------------------------------------------------------}
{ Skalowanie wektora }

function Vector3D_Scale(const Ava: TVector3D; const Ak: single): TVector3D;
begin
  result.x := Ava.x * Ak;
  result.y := Ava.y * Ak;
  result.z := Ava.z * Ak;
end;

{------------------------------------------------------------------------------}
{ Przycinanie wektora }

function Vector3D_Clamp(var Ava: TVector3D; const sMax: single): TVector3D;
begin
{
if  Ava.x >  sMax then Ava.x := sMax else if  Ava.x <  -sMax then Ava.x := -sMax else
if  Ava.y >  sMax then Ava.y := sMax else if  Ava.y <  -sMax then Ava.y := -sMax else
if  Ava.z >  sMax then Ava.z := sMax else if  Ava.z <  -sMax then Ava.z := -sMax else      }
end;



end.

